#include '..\..\..\..\..\_build\include\MiscLib.au3'
#include '..\gen_editorfuncs.au3'

GenerateSyntax()

; ------------------------------------------------------------------------------
; Automatically generate the php file.
; ------------------------------------------------------------------------------
Func GenerateSyntax()
	Local $sOutputFilePath = @ScriptDir & '\lang-autoit.js'
	Local $hFileOpen = FileOpen($sOutputFilePath, $FO_OVERWRITE_CREATE)
	If $hFileOpen = -1 Then Return False

	Local $sHeader = FileRead(@ScriptDir & '\lang-autoit.txt')
	; Update the copyright year(s) field.
	$sHeader = StringRegExpReplace($sHeader, '(\(c\)\h+\d{4}-)\d{4}', '${1}' & @YEAR)

	; Update the AutoIt version field.
	Local $sVersion = IniRead('..\..\..\..\..\_build\config.ini', 'Build', 'AutoItVersion', @AutoItVersion) ; Retrieves the AutoIt version.
	$sHeader = StringRegExpReplace($sHeader, '(AutoIt:\h+v)\V+', '${1}' & $sVersion)

	; Update the updated field.
	$sHeader = StringRegExpReplace($sHeader, '(Updated:\h+)(\d{4})/(\d{2})/(\d{2})', '${1}' & @YEAR & '/' & @MON & '/' & @MDAY)

	; Create keyword list.
	Local $sKeywordList = GetKeywords()
	$sKeywordList = "[PR['PR_KEYWORD'], /^(?:" & $sKeywordList & ")\b/i, null],"
	$sHeader = StringReplace($sHeader, "// AU3_REPLACE_KEYWORDS", $sKeywordList)

	; Create function list.
	Local $sFunctionList = GetFunctions()
	$sFunctionList = "[PR_FUNCTION, /^(?:" & $sFunctionList & ")\b/i, null],"
	$sHeader = StringReplace($sHeader, "// AU3_REPLACE_FUNCTIONS", $sFunctionList)

	FileWrite($hFileOpen, $sHeader)
	FileClose($hFileOpen)

	Return True
EndFunc   ;==>GenerateSyntax

Func GetKeywords()
	Local $sData = FileRead($KEYWORDLIST)
	Local $aKeywords = StringSplit($sData, @CRLF, BitOR($STR_ENTIRESPLIT, $STR_NOCOUNT))
	Local $sKeywordList = ''

	For $i = 0 To UBound($aKeywords) - 1
		If $i Then $sKeywordList &= "|"
		$sKeywordList &= $aKeywords[$i]
	Next
	Return $sKeywordList
EndFunc   ;==>GetKeywords

Func GetFunctions()
	Local $sData = FileRead($FUNCTIONLIST)
	Local $aFunctions = StringSplit($sData, @CRLF, BitOR($STR_ENTIRESPLIT, $STR_NOCOUNT))
	Local $sFunctionList = ''

	For $i = 0 To UBound($aFunctions) - 1
		If $i Then $sFunctionList &= "|"
		$sFunctionList &= $aFunctions[$i]
	Next
	Return $sFunctionList
EndFunc   ;==>GetFunctions
